REM  ZBACKUP 1.1 - Transfer all files from B: or C: on the Zoomer to the PC
REM  By Michael C. Bazarewsky and Chris De Herrera 
REM  Copyright 1995 - All Rights Reserved
REM  Contact Michael via MikeCBaz@AOL.COM regarding errors.

REM  Don't forget to customize the constants for:
REM      Communication speed
REM      Communication port
REM      Maximum number of directory levels deep to worry about
REM      Maximum number of directories per level
REM      Local destination for backup
REM      Root Drive on Zoomer to back up
REM      Root Directory on Zoomer to back up
REM	 Location of ZDOS program

DECLARE SUB zcmd (Cmd$)
DECLARE SUB CopyDir (Level AS INTEGER)
DECLARE SUB HandleDir (Level AS INTEGER)

CONST Speed$ = "9600"
CONST Port$ = "1"
CONST MaxLevels = 4
CONST MaxDirsPerLevel = 20
CONST LocalBackupDir = "D:\Zoomer\Backup2"
CONST ZoomerDrive = "B"
CONST ZoomerRootDir = "\"
CONST ZDosProgName = "C:\Utility\ZDos.com"

DIM SHARED HoldDir$(MaxDirsPerLevel, MaxLevels), CurDir$(MaxLevels)
DIM SHARED Index(MaxLevels) AS INTEGER

ON ERROR GOTO errors

PRINT "ZBACKUP Version 1.1, By Michael C. Bazarewsky and"
PRINT "                        Chris De Herrera, Copyright 1995"
PRINT "Contact Michael at MikeCBaz@aol.com for error reports."

CHDIR LocalBackupDir

zcmd ZoomerDrive + ":"
zcmd "cd " + ZoomerRootDir

HandleDir 0

PRINT "All files were transferred!"

END

errors:
IF ERR = 75 THEN RESUME NEXT
IF ERR = 76 THEN RESUME NEXT
PRINT CHR$(7); "Error! "; ERR, err$
END

SUB CopyDir (Level AS INTEGER)
DIM LineIn AS STRING, Cmd AS STRING

Cmd = ZDosProgName+" /b:" + Speed$ + "/p:" + Port$ + " /c=" + CHR$(34) + "dir" + CHR$(34) + " > result"
SHELL Cmd

REM Copy all the files from the default directory of the Zoomer!

OPEN "result" FOR INPUT AS 1

FOR xx = 1 TO 4
   IF NOT EOF(1) THEN LINE INPUT #1, LineIn
NEXT xx

Index(Level) = 0
WHILE NOT EOF(1)
   LINE INPUT #1, LineIn
   REM  If the file is not a directory and it has something in it, get it!
   IF MID$(LineIn, 14, 5) <> "<DIR>" AND VAL(MID$(LineIn, 14, 10)) > 0 THEN
      filename$ = RTRIM$(LEFT$(LineIn, 12))
      Cmd$ = ZDosProgName+" /b:" + Speed$ + "/p:" + Port$ + " /c=" + CHR$(34) + "get " + filename$ + CHR$(34)
      SHELL Cmd$
   ELSEIF MID$(LineIn, 14, 5) = "<DIR>" AND LEFT$(LineIn, 1) <> "." THEN
      HoldDir$(Index(Level), Level) = RTRIM$(LEFT$(LineIn, 12))
      Index(Level) = Index(Level) + 1
      IF Index(Level) > MaxDirsPerLevel THEN
         PRINT CHR$(7); "Too many directories at a level; increase the constant in the program"
         PRINT "and try again."
         END
      END IF
   END IF
   IF LineIn > "" THEN PRINT LineIn
WEND

CLOSE
KILL "result"

END SUB

SUB HandleDir (Level AS INTEGER)
DIM Count AS INTEGER

IF Level > MaxLevels THEN
   PRINT
   PRINT CHR$(7); "Too many directory levels; increase the constant in the program and try again."
   CLOSE
   END
END IF

CopyDir Level
IF Index(Level) > 0 THEN
   FOR Count = 0 TO Index(Level) - 1
      MKDIR HoldDir$(Count, Level)
      CHDIR HoldDir$(Count, Level)
      zcmd "cd " + HoldDir$(Count, Level)
      HandleDir Level + 1
   NEXT Count
   Index(Level) = 0
END IF
CHDIR ".."
zcmd "cd .."

END SUB

SUB zcmd (Cmd$)
  cmd2$ = ZDosProgName+" /b:" + Speed$ + "/p:" + Port$ + " /c=" + CHR$(34) + Cmd$ + " " + CHR$(34)
  SHELL cmd2$

END SUB

